<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
            <el-form-item label="供应商编号" prop="supplierNo">
              <el-input v-model="queryParams.supplierNo" placeholder="请输入供应商编号" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="供应商名称" prop="supplierName">
              <el-input v-model="queryParams.supplierName" placeholder="请输入供应商名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>

            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8" type="flex" justify="space-between" align="middle">
          <!-- 左侧标题 -->
          <span style="font-size: 16px; font-weight: 500">合同管理信息列表</span>

          <!-- 右侧按钮组 -->
          <div style="display: flex; flex-wrap: nowrap; gap: 10px">
            <el-button type="primary" icon="Plus" @click="handleAdd">创建合同</el-button>
          </div>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="contractList" @selection-change="handleSelectionChange">
        <el-table-column label="主键ID" align="center" prop="id" v-if="false" />
        <el-table-column label="供应商编号" align="center" prop="supplierNo" />
        <el-table-column label="供应商名称" align="center" prop="supplierName" />
        <el-table-column label="合同数" align="center" prop="contractNum" />
        <el-table-column label="有效期内合同" align="center" prop="validContract" />
        <el-table-column label="失效合同" align="center" prop="invalidContract" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" @click="handleManage(scope.row)">管理</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改合同管理对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="contractFormRef" :model="form" :rules="rules" label-width="80px"> </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Contract" lang="ts">
import { listContract, getContract, delContract, addContract, updateContract } from '@/api/supplier/contract';
import { ContractVO, ContractQuery, ContractForm } from '@/api/supplier/contract/types';
import { useRouter } from 'vue-router';

const router = useRouter();
const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const contractList = ref<ContractVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const contractFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: ContractForm = {};
const data = reactive<PageData<ContractForm, ContractQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    supplierNo: undefined,
    supplierName: undefined,
    params: {}
  },
  rules: {}
});

const { queryParams, form, rules } = toRefs(data);

/** 查询合同管理列表 */
const getList = async () => {
  loading.value = true;
  const res = await listContract(queryParams.value);
  contractList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  contractFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: ContractVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 创建合同 */
const handleAdd = () => {
  const urlParams = new URLSearchParams(window.location.search);
  const supplierId = urlParams.get('supplierId');

  router.push({
    path: '/supplier/contract/add',
    query: supplierId ? { supplierId } : {}
  });
};

/** 修改按钮操作 */
const handleUpdate = async (row?: ContractVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getContract(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改合同管理';
};

/** 管理按钮操作 - 路由到合同详情页 */
const handleManage = (row: ContractVO) => {
  router.push({
    // name: 'SupplierContractDetail',
    path: `/supplier/contract/detail`,
    query: {
      supplierId: row.supplierId
    }
  });
};

/** 提交按钮 */
const submitForm = () => {
  contractFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateContract(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addContract(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: ContractVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除合同管理编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delContract(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'supplier/contract/export',
    {
      ...queryParams.value
    },
    `contract_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});

onActivated(() => {
  getList();
});
</script>

<style scoped></style>
